public class DiffuseSpecularFunction extends VectorFunction
{
  public DiffuseFunction d;
  public SpecularFunction s;
  public double prob;

  public DiffuseSpecularFunction(double pSpec)
  {
    d = new DiffuseFunction();
    s = new SpecularFunction();
    prob = pSpec;
  }

  public Vector3 f(Vector3 i, Vector3 n) 
  {
    if (Math.random() < prob) {
      return s.f(i, n);
    } else {
      return d.f(i, n);
    } 
  }
}
